Imports Microsoft.Samples.Workflow.TerminationTrackingServiceSample
Module Module1
    Class Program

        Shared WaitHandle As New AutoResetEvent(False)

        Shared Sub Main()
            Using workflowRuntime As New WorkflowRuntime()

                Const eventSource As String = "TerminationTrackingService"
                Try
                    If Not EventLog.SourceExists(eventSource) Then
                        EventLog.CreateEventSource(eventSource, "Application")
                    End If
                Catch ex As Security.SecurityException
                    Console.WriteLine("Please run the application once with administrative privileges to create event source.")
                    Exit Sub
                End Try

                Dim terminationTracker As TerminationTrackingService = New TerminationTrackingService()
                terminationTracker.EventSource = eventSource
                workflowRuntime.AddService(terminationTracker)


                AddHandler workflowRuntime.WorkflowCompleted, AddressOf OnWorkflowCompleted
                AddHandler workflowRuntime.WorkflowTerminated, AddressOf OnWorkflowTerminated
                AddHandler workflowRuntime.WorkflowCreated, AddressOf OnWorkflowCreated

                Dim workflowInstance As WorkflowInstance
                workflowInstance = workflowRuntime.CreateWorkflow(GetType(Workflow1))
                workflowInstance.Start()
                WaitHandle.WaitOne()
                Console.ReadKey()
            End Using
        End Sub

        Shared Sub OnWorkflowCreated(ByVal sender As Object, ByVal e As WorkflowEventArgs)
            Console.WriteLine(String.Concat("Workflow Instance Started: ", e.WorkflowInstance.InstanceId.ToString()))
        End Sub

        Shared Sub OnWorkflowCompleted(ByVal sender As Object, ByVal e As WorkflowCompletedEventArgs)
            WaitHandle.Set()
        End Sub

        Shared Sub OnWorkflowTerminated(ByVal sender As Object, ByVal e As WorkflowTerminatedEventArgs)
            Console.WriteLine(e.Exception.Message)
            WaitHandle.Set()
        End Sub

    End Class
End Module

