Module Module1
    Class Program

        Shared WaitHandle As New AutoResetEvent(False)

        Shared Sub Main()
            Using workflowRuntime As New WorkflowRuntime()
                AddHandler workflowRuntime.WorkflowCompleted, AddressOf OnWorkflowCompleted
                AddHandler workflowRuntime.WorkflowTerminated, AddressOf OnWorkflowTerminated

                Dim workflowInstance As WorkflowInstance

                'Snippet
                'Register the local data service with the runtime.
                Dim dataService As ExternalDataExchangeService = New ExternalDataExchangeService()
                workflowRuntime.AddService(dataService)
                Dim localService As MagicEightBallService = New MagicEightBallService()
                dataService.AddService(localService)

                'Set up the parameter to pass to the workflow.
                Dim parameters As Dictionary(Of String, Object) = New Dictionary(Of String, Object)
                parameters.Add("Question", "Will this demo work?")


                workflowInstance = workflowRuntime.CreateWorkflow(GetType(Workflow1), parameters)
                workflowInstance.Start()

                'Snippet!
                'Wait for the user to indicate they want to shake the ball.
                Console.WriteLine("Press any key to shake the magic eight ball.")
                Console.ReadKey()
                'Fire the shake the ball event.
                localService.ShakeTheBall(workflowInstance.InstanceId)

                WaitHandle.WaitOne()
                Console.ReadKey()
            End Using
        End Sub

        Shared Sub OnWorkflowCompleted(ByVal sender As Object, ByVal e As WorkflowCompletedEventArgs)
            WaitHandle.Set()
        End Sub

        Shared Sub OnWorkflowTerminated(ByVal sender As Object, ByVal e As WorkflowTerminatedEventArgs)
            Console.WriteLine(e.Exception.Message)
            WaitHandle.Set()
        End Sub

    End Class
End Module

